/******************************************************************************

  deconstruct_index SW Dec 98

******************************************************************************/

#include "bss.h"

char *Usage = "\
Produces index streamer file from named secondary indexes and postings files\n\
Usage: %s index-type SI-name SI-chunksize #-pstg-vols \n\
PF-name .. output-file-name verbosity convert\n\n\
Index types supported are 8-13 only\n\
SI chunksize defaults to 8192 if given as 0\n\
If convert is non-zero IRNs are converted from 3 to 4 or 4 to 3 bytes\n\
as appropriate\n\
Number of posting file volumes is 1-%d\n\
Output goes to stdout if file name given as -\n\
Verbosity is 0-4, 2 recommended.\n" ;


main(int argc, char *argv[], char *envp[]) 
{
  int ixtype ;
  char *si_name ;
  int chunksize ;
  int numvols ; 
  char *oi_names[MAXIXVOLS + 1] ;
  char *outname ;
  int verbosity ;
  int result ;
  int j ;
  BOOL convert ;
 usage:
  if ( argc < 8 || strcmp(argv[1], "-h") == 0 ) {
    fprintf(stderr, Usage, argv[0], MAXIXVOLS) ;
    exit(1) ;
  }

  ixtype = atoi(argv[1]) ;
  if ( ixtype < 8 || ixtype > 13 ) goto usage ;
  si_name = argv[2] ;
  chunksize = atoi(argv[3]) ;
  numvols = atoi(argv[4]) ; 
  if ( numvols < 1 || numvols > MAXIXVOLS ) goto usage ;
  if ( argc < 8 + numvols ) goto usage ;
  outname = argv[argc - 3] ;
  verbosity = atoi(argv[argc - 2]) ;
  convert = atoi(argv[argc - 1]) ;
  for ( j = 0 ; j < numvols ; j++ ) oi_names[j] = argv[5 + j] ;
  result = ix_deconstruct(ixtype, si_name, numvols, oi_names, outname,
			  chunksize, verbosity, convert) ;
  exit(result) ;
}
