/******************************************************************************

  frig_dir.c  Prog to add constant onto .dir recs and put them
  to stdout.

  Intended for use in concatenating runtime okapi directories.

  (Add size of head bibfile / recmult to each dir record of tail bibfile
  and concatenate the result to the dir records of the head file.)

  

******************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include "bss.h"

long long reverse_64() ;

int Toktab ;			/* Dummy */

main(argc, argv)
     int argc ;
     char **argv ;
{
  long long offset = 0 ;
  long long d ;

  int count=0 ;
  int size = 4 ;
  int i ;

  if ( argc < 2 ) {
    fprintf(stderr,
   "Usage: %s [-size 4|5] [-offset offset]\n", argv[0]) ;
    exit(1) ;

  }
  fprintf(stderr,
	  "Warning!! Make sure you have backed up any .dir file you are\n") ;
  fprintf(stderr,
	  "modifying. This prog leaves the responsibility in YOUR hands.\n") ;
  fprintf(stderr, "If in doubt, you have 5 seconds to ^C\n\n") ;
  sleep(5) ;
  fprintf(stderr, "About to start..") ;
  sleep(2) ;
  fprintf(stderr, " starting\n") ;
  for ( i = 1 ; i < argc - 1 ; i++ ) {
    if ( strcmp(argv[i], "-size") == 0 ) size = atoi(argv[++i]) ;
    else if ( strcmp(argv[i], "-offset") == 0 )
      offset = (long long)atoll(argv[++i]) ;
    else {
      fprintf(stderr, "Unrecognized arg %s\n", argv[i]) ;
      fprintf(stderr,
      "Usage: %s [-size 4|5] [-offset offset]\n", argv[0]) ;
      exit(1) ;
    }
  }
  if ( size != 4 && size != 5 ) {
    fprintf(stderr, "Size must be 4 or 5\n") ;
    exit(1) ;
  }
  if ( size == 5 && sizeof(offset) < 5 ) {
    fprintf(stderr,
 "Can't process 5-byte records on this machine, not compiled for long long\n");
    exit(1) ;
  }
  while ( ! feof(stdin) ) {
    d = 0 ;
    if ( sizeof(offset) == 8 ) {
      if ( size == 4 ) fread((char *)&d + 4, 4, 1, stdin) ;
      else fread((char *)&d + 3, 5, 1, stdin) ;
#if ! HILO
      d = reverse_64(d) ;
#endif
    }
    else {
      fread((char *)&d, 4, 1, stdin) ;
#if ! HILO
      d = reverse(d) ;
#endif
    }
    if ( feof(stdin) ) break ;
    
    d += offset ;
    if ( sizeof(offset) == 8 ) {
#if ! HILO
      d = reverse_64(d) ;
#endif
      if ( size == 4 ) fwrite((char *)&d + 4, 4, 1, stdout) ;
      else fwrite((char *)&d + 3, 5, 1, stdout) ;
    }
    else {
#if ! HILO
      d = reverse(d) ;
#endif
      fwrite((char *)&d, 4, 1, stdout) ;
    }
    count++ ;
  }
  fprintf(stderr, "Done %d records\n", count) ;
  exit(0) ;
}
