/* read_mergefile
   Index types 4 - 10 incl */
#include "bss.h"
unsigned Toktab ;		/* Dummy for utils.c */
char *expand_pos_text() ;
int
main(argc, argv)
     char **argv ;
     int argc ;
{
  U_pos p ;
  int recnum = 0 ;
  int prevrecnum = 0 ;
  int maxrecnum = 0 ;
  int minrecnum = 0x7ffffffe ;
  int nopos = 0 ;
  int termonly = 0 ;
  int inp ;
  int tl ;
  int np ;
  int ttf ;
  int pcount ;
  unsigned short wpcount ;
  int i ;
  int maxtl = 0 ;
  int termnum = 0 ;
  int silent = 0 ;
  int spurious = 0 ;
  char term[512] ;
  char prevterm[512] ;
  int comp ;
  char maxterm[512] ;
  int itype ;
  unsigned magic ;
  int large_rn = 0 ;		/* TRUE if 4-byte recnums */
  char sep = ':' ;
  int started = 0 ;

  if ( argc < 2 ) goto Usage ;
  itype = atoi(argv[argc - 1]) ;
  if ( itype < 4 || itype > 13 ) goto Usage ;
  for ( i = 1 ; i < argc - 1 ; i++ ) {
    if ( strcmp(argv[i], "-silent") == 0 ) silent = 1 ;
    else if ( strcmp(argv[i], "-nopos") == 0 ) nopos = 1 ;
    else if ( strcmp(argv[i], "-termonly") == 0 ) {termonly = 1 ; nopos = 1 ;}
    else if ( strcmp(argv[i], "-help") == 0 ) goto Usage ;
    else if ( strcmp(argv[i], "-sep") == 0 ||  strcmp(argv[i], "-F") == 0 )
      sep = *argv[++i] ;
    else goto Usage ;
  }
	      
  if ( itype >= 11 && itype <= 13 ) large_rn = 1 ;
  magic = getw(stdin) ;
  if ( magic != MAGIC_MERGEFILE ) {
    fprintf(stderr, "Input starts with wrong magic number %08x\n",
	    magic) ;
    exit(1) ;
  }

  *prevterm = '\0' ;
  *maxterm = '\0' ;
  while ( 1 ) {
    /* Read a term */
    inp = getchar() ;
    if ( inp == EOF ) break ;
    tl = (unsigned) inp ;
    if (fread(term, tl, 1, stdin) != 1) {
      fprintf(stderr,
	      "End of input or read zero length term.\n\
Last term %s, term length %d\n",
	      prevterm, tl) ;
      break ;
    }
    *(term + tl) = '\0' ;
    termnum++ ;
    if ( ! silent && tl > maxtl ) {
      fprintf(stderr, "Term %s length %d termnum %d\n",
	      term, tl, termnum) ;
      maxtl = tl ;
    }
    else if ( tl == 0 ) {
      fprintf(stderr, "Zero length term, termnum %d\n", termnum) ;
    }
    if ( (comp = strcmp(term, prevterm)) <= 0 ) 
      fprintf(stderr, "Term %s <= previous term %s\n", term, prevterm) ;
    strcpy(prevterm, term) ;
    if ( ! silent && termnum % 10000 == 0 ) {
      fprintf(stderr, "(%d) %s\n", termnum, term) ;
    }
    np = ttf = prevrecnum = 0 ;
    while ( 1 ) {
      /* Read recnum */
      recnum = 0 ;
      if ( ! large_rn ) {
#if HILO
	fread((char *)&recnum + 1, 3, 1, stdin) ;
#else
	fread((char *)&recnum, 3, 1, stdin) ;
#endif
	if ( (unsigned)recnum == 0x00ffffff ) break ;
      }
      else {
	fread((char *)&recnum, 4, 1, stdin) ;
	if ( (unsigned)recnum == 0xffffffff ) break ;
      }
      if ( recnum <= prevrecnum ) {
	fprintf(stderr, "Recnums out of sequence at term %s, %d follows %d\n",
		term, recnum, prevrecnum) ;
	break ;
      }
      prevrecnum = recnum ;
      np++ ;
      if ( ! termonly ) {
	if ( started ) putchar('\n') ;
	else started = 1 ;
	printf("%s%c%d%c", term, sep, recnum, sep) ;
      }
      if ( spurious ) fprintf(stderr, "\n%s %d ", term, recnum) ;
      if ( recnum > maxrecnum ) {
	maxrecnum = recnum ;
	if ( ! silent && ! termonly )
	  fprintf(stderr, "Highest recnum %u at term %s\n",
		  (unsigned)recnum, term) ;
      }
      if ( recnum < minrecnum ) {
	minrecnum = recnum ;
	if ( ! silent && ! termonly )
	  fprintf(stderr, "Lowest recnum %u at term %s\n",
		  (unsigned)recnum, term) ;
      }
      /* Read the positional recs */
      pcount = 0 ;
      switch (itype) {
      case 10:
      case 11:
	fread((char *)&wpcount, sizeof(short), 1, stdin) ;
	pcount += wpcount ;
	break ;
      case 12:
      case 8:
      case 6:
      case 4:
	while ( (p.pos = getw(stdin)) != 0xffffffff ) {
	  pcount++ ;
	  if ( ! nopos ) {
	    if ( pcount < 10 ) {
	      printf("%s%c", expand_pos_text(&p), sep) ;
	      if ( spurious) fprintf(stderr, "%s ", expand_pos_text(&p)) ;
	    }
	    else printf(".") ;
	  }
	}
	break ;
      case 5:
      case 7:
      case 9:
      case 13:
	while ( (p.pos = getw(stdin)) != 0xffffffff ) {
	  pcount++ ;
	  if ( ! nopos ) {
	    if ( pcount < 10 ) {
	      printf("%s%c", expand_pos6(&p), sep) ;
	      if ( spurious) fprintf(stderr, "%s ", expand_pos6(&p)) ;
	    }
	    else printf(".") ;
	  }
	}
	break ;
      } /* (switch) */
      if ( ! termonly ) printf("%d", pcount) ;
      if ( spurious ) fprintf(stderr, "%d", pcount) ;
      ttf += pcount ;
    }
    if ( recnum <= prevrecnum ) break ;
    if ( termonly ) printf("%s%c%d%c%d\n", term, sep, np, sep, ttf) ;
  }
  if ( ! termonly ) printf("\n") ;
  if ( ! silent ) fprintf(stderr, "%d terms\n", termnum) ;
  if ( ! silent ) fprintf(stderr, "Highest rec %d, lowest rec %d\n",
			  maxrecnum, minrecnum) ;
  exit(0) ;
Usage:
  fprintf(stderr,
 "Usage: %s [-nopos] [-termonly] [-silent] [-sep <field separator char>] [-help] <index-type>\n",
	  argv[0]) ;
  fprintf(stderr, "Index type must be given and is in the range 4 - 13\n") ;
  fprintf(stderr,
"Needs an Okapi index runfile, starting with the appropriate 4-byte magic\n\
number, on stdin, and outputs (if not termonly) lines of\n\
                      <term>:<recnum>[:<pos>]:<tf>\n\
Only the first 10 pos records are output, the others being replaced by dots.\n\
If termonly, there is one record for each term and the recnum field is\n\
replaced with the number of postings for the term, and the tf field by\n\
the total tf for the term.\n\
Default field separator is a colon. Other characters may be used, but\n\
note that terms may have embedded white space.\n\
") ;
  exit(1) ;
}
