/******************************************************************************

  Rudimentary stoplist setup and search

******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXSTOPLEN 512
#define MAXSTOPS 4096

char **Stoplist ;

int
setup_stoplist(char *stopfilename)
{
  FILE *stopfile ;
  char **p ;
  char buf[MAXSTOPLEN] ;
  int l, nstops = 0 ;

  stopfile = fopen(stopfilename, "r") ;
  if ( stopfile == NULL ) return -1 ;
  p = Stoplist = (char **)calloc(MAXSTOPS, sizeof(char *)) ;
  if ( p == NULL ) return -1 ;
  nstops = 0 ;
  while ( fgets(buf, MAXSTOPLEN, stopfile) ) {
    if ( (l = strlen(buf) - 1) <= 0 ) continue ;
    *(buf + l) = '\0' ; 
    *p = strdup(buf) ;
    if ( *p == NULL ) /* Exception message here */ break ;
    p++ ;
    nstops++ ;
  }
  fclose(stopfile) ;
  return nstops ;
}

/* Swapping saved ~~10% with 186-wd stoplist and 20meg file */

int
simple_stop(char *term) 
{
  int found = 0 ;
  char **p = Stoplist, *tmp ;
  while ( ! found && *p ) {
    if ( strcmp(term, *p) == 0 ) {
      found = 1 ;
      /*      if ( p != Stoplist ) {
	tmp = *(p-1) ;
	*(p-1) = *p ;
	*p = tmp ;
	} */
    }
    else p++ ;
  }
  return found ;
}

      
