#! /export/CISR-D/perl-5.8.0/perl 


# FV May 2003
# Takes a collection of xml files as input and builds one single xml file.
# Important: if the collection is bigger than 2Gb, then support for 64bit
#            and large files is needed.

use Shell qw(rm date);

my $collection_start_tag = "<reuters>";
my $collection_end_tag = "</reuters>";
my $ARCHIVE_PATH = "/export/CISR-D/fabio/collections/raw/reuters";
my $OUT_XML_PATH = "/export/CISR-D/fabio/collections/bibfiles/reuters";
my $OUT_XML_FILE = "$OUT_XML_PATH/reuters.xml.bib";


my $tot_xml_docs = 0;

open (OUT_XML_FILE, ">$OUT_XML_FILE") or die "Cannot open $OUT_XML_FILE ($!)\n";

$date = date();

#Print log info
print "xmlbuilder. Collection is: $ARCHIVE_PATH\n";
print "Started at: $date\n";
print "building...";

#############################
# Loop for reading files    #
#############################

chdir $ARCHIVE_PATH;
foreach $xml_file (glob("*.xml")) {
    &handle($xml_file);
#    rm $xml_file;
}

print OUT_XML_FILE "$collection_end_tag\n";

close (OUT_XML_FILE) or die "Cannot close $OUT_XML_FILE ($!)\n";

$date = date();

print "Finished at: $date\n";
print "$tot_xml_docs xml documents processed\n";
print "output sent to: $OUT_XML_FILE\n";

####################################
# subroutine to change the format #
####################################

sub handle{ #called by above loop

    my $insert_next_line = 0; 
    my $text;

    open (IN,$_[0]);
    while ($line = <IN>){                    # read lines into a variable
       	if($line =~ /\<\?xml version\=\".*/) {     
	    if ($tot_xml_docs == 0) {
# this is the first document, we have to leave  the xml header
		$insert_next_line = 1;
		$text = $text . $line; 
	    }
	}
	elsif($insert_next_line == 1) {
	    $text = $text . "$collection_start_tag\n" . $line;
	    $insert_next_line = 0;
	}  
	else {
	    $text = $text . $line;
	}
	
    }
    print OUT_XML_FILE $text;
    close (IN);
    $tot_xml_docs++;
}
