/*****************************************************************************

  chi.c  2-way chi-square statistic

*****************************************************************************/

#include <stdio.h>

float chi_values[10][7] = {
  { 0, 2.71, 3.84, 5.02, 6.63, 7.88 },
  { 0, 4.61, 5.99, 7.38, 9.21, 10.6 },
  { 0, 6.25, 7.81, 9.35, 11.3, 12.8 },
  { 0, 7.78, 9.49, 11.1, 13.3, 14.9 },
  { 0, 9.24, 11.1, 12.8, 15.1, 16.7 },
  { 0, 10.6, 12.6, 14.4, 16.8, 18.5 },
  { 0, 12.0, 14.1, 16.0, 18.5, 20.3 },
  { 0, 13.4, 15.5, 17.5, 20.1, 22.0 },
  { 0, 14.7, 16.9, 19.0, 21.7, 23.6 },
  { 0, 16.0, 18.3, 20.5, 23.2, 25.2 },
} ;
/* The above are the .9, .95, .975, .99 and .995 points for
   1 - 10 */

char *sig[] = { "Not sig", "Sig at .9", "Sig at .95", "Sig at .975",
		  "Sig at .99", "Sig at .995" } ;

main()
{
  int obs[10][10] ;
  /* The 0th row and col are for totals */
  float expect, diff, chisq ;
  int tot ;
  int r, c ;
  int df ;
  int i, j ;

  while (1) {
    printf("Number of rows, cols? ") ;
    scanf("%d %d", &r, &c) ;
    if ( r < 2 || c < 2 ) {
      fprintf(stderr, "Must be at least 2 rows and cols\n") ;
      continue ;
    }
    df = ( r - 1 ) * ( c - 1 ) ;
    if ( df > 10 ) {
      fprintf(stderr, "Too many df\n") ;
      continue ;
    }
    tot = 0 ;
    for ( j = 1 ; j <= c ; j++ ) obs[0][j] = 0 ;
    for ( i = 1 ; i <= r ; i++ ) {
      printf("Enter row %d : ", i) ;
      obs[i][0] = 0 ;
      for ( j = 1 ; j <= c ; j++ ) {
	scanf("%d", &obs[i][j]) ;
	obs[0][j] += obs[i][j] ;
	obs[i][0] += obs[i][j] ;
	tot += obs[i][j] ;
      }
    }

    chisq = 0 ;
    for ( i = 1 ; i <= r ; i++ ) {
      for ( j = 1 ; j <= c ; j++ ) {
	expect = (float)(obs[i][0] * obs[0][j]) / tot ;
	fprintf(stderr, "e(%d)(%d)=%f\n", i, j, expect) ;
	diff = expect - obs[i][j] ;
	chisq += diff * diff / expect ;
      }
    }
    printf("Chi-square = %f, %d d.f.\n", chisq, (r - 1) * (c - 1) ) ;
    for (i = 5 ; i >= 0 && chisq < chi_values[df - 1][i]; i-- ) ;
    printf("%s\n", sig[i]) ;
      
  }
}
