/******************************************************************************

  Include file for routing term selection procedures

  Sw June 95

******************************************************************************/

#include "bss.h"

#define MAXTERMS 512
#define MAXSTATES 64
#define MAXSTAGES MAXSTATES - 3

#define BROOKES 1
#define LBROOKES 10
#define DIFFMEANS 2
#define RECALL 3
#define COMBINED_MEASURE 4
#define AVEP 5
#define TREC_AVEP 6
#define RPREC 7
#define CBM1 8
#define CBM2 9
#define T_AVEP_RCL 11
/* NB 101-103 and 201-202 are researved in this context for filtering utility
   functions. The definitions are in bss.h (TS_LF1 etc) */

#define SMALLN 256
#define AVEP_GRAN 10
#define DEFAULT_MAX_SKIP 100

extern FILE *Err_file ;

extern char *terms[MAXTERMS] ;
extern double weights[MAXTERMS] ;
extern double origweights[MAXTERMS] ;
extern double minweights[MAXTERMS] ;
extern int sets[MAXTERMS] ;
extern int np[MAXTERMS] ;
extern int r[MAXTERMS] ;
extern double br[MAXTERMS] ;
extern int incl[MAXTERMS] ;
extern int successive_failures[MAXTERMS] ;
extern int dropped[MAXTERMS] ;
extern int skipped[MAXTERMS] ;
extern int examined[MAXTERMS] ;
extern double assoc[MAXTERMS][MAXTERMS] ;

struct term {			/* Constant data for each term */
  char *t ;
  double ow ;
  int set ;
  int np ;
  int r ;
} ;

struct state {
  int live ;			/* True if in use */
  int c_set ;			/* Current set */
  int new_set ;			/* After perturb() */
  double score ;		/* Score of current set */
  double new_score ;		/* After perturb() */
  double recall, new_recall ;
  int stage ;			/* Stage last changed */
  double cutoff ;
  int cssize ;
  double w[MAXTERMS], nw[MAXTERMS] ; /* Current and new weights resp */
  double scores[MAXTERMS] ;	/* Probably unneeded */
  int incl[MAXTERMS] ;
  int inclterms ;		/* Number of terms included */
  int failures[MAXTERMS] ;
  int dropped[MAXTERMS] ;
  int skipped[MAXTERMS] ;
  int examined[MAXTERMS] ;
} ;

extern struct term Terms[MAXTERMS] ;
extern struct state States[MAXSTATES] ;
extern struct state *Stage_final_state[MAXSTAGES] ;
extern struct state *C_state, *Best_state, *Realbest_state ;
extern struct state *getstate() ;
extern int Numstates ;

extern int Hold ;
extern int Debug ;
extern int res ;
extern int silent ;
extern int Use_cutoff ;
extern int Mark_early ;
extern int do_minwts ;
extern double Cutoff_factor ;
extern double Tar_factor ;	/* For wtd ave of AVEP and RCL */
extern double k1, b ;
extern char *Op ;
extern int R ;

double brookes() ;
double diff_means() ;
double score() ;
double do_assoc() ;
double wt_of_nth() ;
double wt_of_last_common() ;
double vw(), vw1() ;

#define DO_MINWTS 0
#define USING_CUTOFF
/*#define TAR_FACTOR .5*/
#define TAR_FACTOR .75
#define OP "bm2500"
#define CUTOFF_FACTOR 0.125
#define MARK_EARLY

#include "I0.h"
     
