/******************************************************************************

  Routing 1994

  Modifying for 1995 (TREC-5)  SW May 96

  rtgterms_pass1.c

  Read each rel doc for a query, show text field, superparse it
  and output one record per line.
  
  Input is list of docnos of reldocs on stdin (also topic number (as argv[2])
  for diagnostics, and the name of a file to write the total term frequency
  of terms extracted from reldocs to).

  Output is <term>, and total term frequency written to argv[1]

  SW June 94

  May 95: revising for TREC4

******************************************************************************/

#define DEBUG
#undef DEBUG
#define I0q if (res = i0(command, response) < 0) {\
  sprintf(command, "perror") ;\
  i0(command, response) ;\
  fprintf(stderr, response) ;\
  goto error ; }

#ifdef DEBUG
#define I0 fprintf(stderr, "%s\n", command) ;\
if (res = i0(command, response) < 0) {\
  sprintf(command, "perror") ;\
  i0(command, response) ;\
  fprintf(stderr, response) ;\
  goto error ; }\
  else fprintf(stderr, response) ;
#else
#define I0 I0q
#endif

#define SKIP_IS 1
#include "bss.h"
#include <signal.h>
#include <string.h>

extern FILE *Err_file ;

void eexit() ;

char buf[1024] ;
char com[1024] ;
char command[8 * 1024 * 1024] ;
char response[8 * 1024 * 1024] ;

main(argc, argv)
     int argc ;
     char **argv ;
{
  int res ;
  int numrels ;
  int tf_rec ; 
  int doclen ;
  int totlen ;
  int tot_tf ;
  int max_tf ;
  int spurious = 0 ;
  int nk ;
  int topnum ;
  int Skip_Is = SKIP_IS ;
  int Is = 0 ;			/* Count occurrences of 'I' terms */
  FILE *tot_tf_file ;
  char *envp ;
  char *attr ;
  char *dn_attr ;
  char *dbname ;
  char *p, *ip ;

  signal(SIGHUP, eexit);
  signal(SIGQUIT, eexit);
  signal(SIGINT, eexit);

  if ( argc < 3 ) {
    fprintf(stderr, "pass1: usage: pass1 <tot_tf_file> <topnum>\n") ;
    exit(1) ;
  }
  if ( (tot_tf_file = fopen(argv[1], "w")) == NULL ) {
    fprintf(stderr, "pass1: can't open tot_tf_file %s\n", argv[1]) ;
    exit(1) ;
  }
  topnum = atoi(argv[2]) ;

  dn_attr = "dn" ;

  Err_file = stderr ;

  numrels = totlen = tot_tf = max_tf = 0 ;
  iinit() ;
  if ( (envp = getenv("BSS_DB")) == NULL ) {
    fprintf(stderr, "Pass1: no value for BSS_DB\n") ;
    exit(1) ;
  }
  dbname = envp ;
  sprintf(command, "ch %s\n", dbname) ;
  I0
  if ( (envp = getenv("BSS_LIMIT")) != NULL && *envp != '\0' ) {
    sprintf(command, "set l=%s\n", envp) ;
    I0 
  }
  attr = "default" ;
  if ( (envp = getenv("BSS_ATTRIBUTE")) != NULL && *envp != '\0' ) {
    attr = envp ;
    sprintf(command, "set a=%s\n", attr) ;
    I0
  }
  if ( (envp = getenv("BSS_DN_ATTRIBUTE")) != NULL && *envp != '\0' ) dn_attr = envp ;

  while ( 1 ) {
    gets(buf) ;			/* Read a rel docno */
    if ( feof(stdin)) break ;
    numrels++ ;
    fprintf(stderr, "pass1: Doing %d:%s\n", numrels, buf) ;
    sprintf(command, "f a=%s t=%s", dn_attr, buf) ;
    I0 ;
    if ( atoi(strstr(response, "np=") + 3) == 0 ) {
      fprintf(stderr, "%s not found\n", buf) ;
      /* doc not found, should only be because of limit */
      sprintf(command, "delete %d", atoi(response + 1) ) ;
      I0 ;
      continue ;
    }
    sprintf(command, "s r=0 s=0 f=200\n") ;
    I0q ;
    doclen = strlen(response) ;
    totlen += doclen ;
    /* A direct function call is needed for the superparse because the
       parser breaks at newlines */

    nk = bss_superparse(response, doclen, attr, command) ;
    if ( nk < 0 ) {
      fprintf(stderr, "pass1: %d: can't parse %s (length %d)\n",
	      topnum, buf, doclen) ;
      totlen -= doclen ;
      numrels-- ;
    }
    else {
      ip = command ;
      tf_rec = 0 ;
      while ( nk-- ) {
	if ( *ip == 'H' || *ip == 'F' ||
	    strlen(ip + 1) == 0 || strlen(ip) == 0) {
	  ip += strlen(ip) + 1 ;
	  ip += strlen(ip) + 1 ;
	  continue ;
	}
	else if ( *ip != ' ' && *ip != 'S' && *ip != 'G' && *ip != 'I' ) {
	  spurious++ ;
	  ip += strlen(ip) + 1 ;
	  ip += strlen(ip) + 1 ;
	  continue ;
	}
	if ( Skip_Is && *ip == 'I' ) {
	  Is++ ;
	  ip += strlen(ip) + 1 ;
	  ip += strlen(ip) + 1 ;
	  continue ;
	}
	printf("%s\n", ip + 1) ;
	tf_rec++ ;
	tot_tf++ ;
	ip += strlen(ip) + 1 ;
	ip += strlen(ip) + 1 ;
      }
    }
    sprintf(command, "del 0\n") ;
    I0q ;
    if ( tf_rec > max_tf ) {
      max_tf = tf_rec ;
      fprintf(stderr, "pass1: %d: %s: ttf=%d\n", topnum, buf, tf_rec) ;
    }
  }

  fprintf(stderr, "pass1: %d: totlen=%d\n", topnum, totlen) ;
  fprintf(tot_tf_file, "%d\n", tot_tf) ;
  if ( spurious > 0 )
    fprintf(stderr, "pass1: %d: %d spurious terms\n", topnum, spurious) ;
  if ( Is > 0 )
    fprintf(stderr, "pass1: %d: %d 'I' terms skipped\n", topnum, Is) ;
  fclose(tot_tf_file) ;
  iexit() ;
  exit(0) ;
 error:
  iexit() ;
  exit(1) ;

}

void
eexit()
{
  iexit() ;
  exit(0) ;
}
